//+------------------------------------------------------------------+
//|                                                  ThickCandle.mq4 |
//|                                       Copyright  2009, TheXpert |
//|                                           theforexpert@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, TheXpert"
#property link      "theforexpert@gmail.com"

#property indicator_chart_window

extern int BarsCount = 15;
extern color CandleColor = Gray;
extern color BullishColor = Blue;
extern color BearishColor = Red;

extern int Offset = 0;

datetime LastTime = 0;

string EAID;

int init()
{
   EAID = "ThickCandle" + Symbol();
   
   return(0);
}

bool firstRun = true;

int start()
{
   if (firstRun)
   {
      firstRun = false;
   }
   else
   {
      if (ObjectFind(EAID + "body") != -1)
      {
         double left = ObjectGet(EAID + "body", OBJPROP_TIME1);
         double right = ObjectGet(EAID + "body", OBJPROP_TIME2);
         
         BarsCount = MathAbs(iBarShift(Symbol(), Period(), left) - iBarShift(Symbol(), Period(), right));
      }
   }
   
   datetime xleft = Time[0] - Offset*Period()*60;
   datetime xright = Time[0] - BarsCount*Period()*60;
   datetime xmidleft = Time[0] - ((BarsCount + Offset)/2 + 1)*Period()*60;
   datetime xmidright = xmidleft + Period()*60;

   Print(BarsCount);   
   double open = Open[BarsCount + Offset - 1];
   double close = Close[Offset];
   
   double candleTop = High[iHighest(Symbol(), Period(), MODE_HIGH, BarsCount, Offset)];
   
   double bodyTop = MathMax(open, close);
   double bodyBottom = MathMin(open, close);
   
   double candleBottom = Low[iLowest(Symbol(), Period(), MODE_LOW, BarsCount, Offset)];
   
   color bodyColor = CandleColor;
   if (NormalizeDouble(close - open, Digits) > 0) bodyColor = BullishColor;
   if (NormalizeDouble(close - open, Digits) < 0) bodyColor = BearishColor;
   
   ObjectDelete(EAID + "body");
   ObjectCreate(EAID + "body", OBJ_RECTANGLE, 0, xleft, bodyTop, xright, bodyBottom);
   ObjectSet(EAID + "body", OBJPROP_COLOR, bodyColor);
   
   ObjectDelete(EAID + "top");
   ObjectCreate(EAID + "top", OBJ_RECTANGLE, 0, xmidleft, bodyTop, xmidright, candleTop);
   ObjectSet(EAID + "top", OBJPROP_COLOR, CandleColor);

   ObjectDelete(EAID + "bottom");
   ObjectCreate(EAID + "bottom", OBJ_RECTANGLE, 0, xmidleft, bodyBottom, xmidright, candleBottom);
   ObjectSet(EAID + "bottom", OBJPROP_COLOR, CandleColor);
   
}

int deinit ()
{
   ObjectDelete(EAID + "body");
   ObjectDelete(EAID + "top");
   ObjectDelete(EAID + "bottom");
}